diff --git a/filesetup.c b/filesetup.c
index ed3646a4b..70b1c72e7 100644
--- a/filesetup.c
+++ b/filesetup.c
@@ -934,9 +934,9 @@ static bool create_work_dirs(struct thread_data *td, const char *fname)
 		*end = '\0';
 		errno = 0;
 #ifdef CONFIG_HAVE_MKDIR_TWO
-		if (mkdir(path, 0600) && errno != EEXIST) {
+		if (mkdir(start, 0600) && errno != EEXIST) {
 #else
-		if (mkdir(path) && errno != EEXIST) {
+		if (fio_mkdir(start, 0600) && errno != EEXIST) {
 #endif
 			log_err("fio: failed to create dir (%s): %d\n",
 				start, errno);
diff --git a/os/os-windows.h b/os/os-windows.h
index 3e9f73413..68c53f286 100644
--- a/os/os-windows.h
+++ b/os/os-windows.h
@@ -197,6 +197,25 @@ static inline int fio_set_sched_idle(void)
 	return (SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_IDLE))? 0 : -1;
 }
 
+static inline int fio_mkdir(const char *path, mode_t mode) {
+	DWORD dwAttr = GetFileAttributesA(path);
+
+	log_err("path = %s, dwAttr = %d\n", path, dwAttr);
+	if (dwAttr != INVALID_FILE_ATTRIBUTES &&
+	    (dwAttr & FILE_ATTRIBUTE_DIRECTORY)) {
+		errno = EEXIST;
+		return -1;
+	}
+
+	if (CreateDirectoryA(path, NULL) == 0) {
+		log_err("CreateDirectoryA = %d\n", GetLastError());
+		errno = win_to_posix_error(GetLastError());
+		return -1;
+	}
+
+	return 0;
+}
+
 #ifdef CONFIG_WINDOWS_XP
 #include "os-windows-xp.h"
 #else
